SystemOrganization addCategory: 'tODE-GemTools'!

!ObjectLogEntry methodsFor: '*tode-gemtools' stamp: 'dkh 05/21/2011 11:21'!
id 

	^self asOop! !

!JQueryInstance methodsFor: '*tode-gemtools' stamp: 'dkh 05/21/2011 10:27'!
id
	^arguments first! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*tode-gemtools' stamp: 'dkh 05/21/2011 10:28'!
selectorsToInclude
	^ #(gridlocaleenJs jqueryjqGridminJs uijqgridCss jquerylayoutminJs)! !

!DateAndTime methodsFor: '*tode-gemtools' stamp: 'dkh 05/21/2011 11:40'!
jsonOn: aStream

	aStream nextPutAll: self asSeconds printString! !

TOObjectFrame subclass: #TOObjectLogFrame
	instanceVariableNames: 'objectLogSpec useBasicFrame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-GemTools'!

!TOObjectLogFrame methodsFor: 'accessing' stamp: 'dkh 05/21/2011 12:13'!
calculateObjectLogSpec

	^{
		self tabSpec: #summary renderSelector: #renderSummaryOn:spec:main:.
		self tabSpec: #fatal renderSelector: #renderFatalOn:spec:main:.
		self tabSpec: #error renderSelector: #renderErrorOn:spec:main:.
		self tabSpec: #warn renderSelector: #renderWarnOn:spec:main:.
		self tabSpec: #info renderSelector: #renderInfoOn:spec:main:.
		self tabSpec: #debug renderSelector: #renderDebugOn:spec:main:.
		self tabSpec: #trace renderSelector: #renderTraceOn:spec:main:.
		self tabSpec: #transcript renderSelector: #renderTranscriptOn:spec:main:.
		self tabSpec: #classic renderSelector: #renderClassicOn:spec:main:.
	}! !

!TOObjectLogFrame methodsFor: 'accessing' stamp: 'dkh 05/21/2011 07:46'!
centerTabSpec

	self useBasicFrame ifTrue: [ ^super centerTabSpec ].
	^self objectLogSpec! !

!TOObjectLogFrame methodsFor: 'accessing' stamp: 'dkh 05/21/2011 07:46'!
objectLogSpec

	objectLogSpec ifNil: [ objectLogSpec := self calculateObjectLogSpec ].
	^objectLogSpec! !

!TOObjectLogFrame methodsFor: 'accessing' stamp: 'dkh 05/21/2011 12:42'!
tabSpec: id renderSelector: renderSelector

	^(TOTabSpec new)
		id: id;
		rendererClass: TOObjectLog;
		receiver: self object;
		frame: self;
		label: id asString;
		order: 0;
		group: 'object log';
		renderSelector: renderSelector! !

!TOObjectLogFrame methodsFor: 'accessing' stamp: 'dkh 05/21/2011 07:39'!
useBasicFrame

	useBasicFrame ifNil: [ useBasicFrame := false ].
	^useBasicFrame! !

TOHome subclass: #TOGemToolsHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-GemTools'!

!TOGemToolsHome classSide methodsFor: 'class initialization' stamp: 'dkh 05/21/2011 07:18'!
initialize
	"self initialize"
	
	self select! !

!TOGemToolsHome methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:19'!
renderGemToolsOn: html main: main

	html strong: 'Workspaces: '.
	self renderWorkspacesOn: html main: main.
	html break.
	html strong: 'Tools: '.
	self renderToolsOn: html main: main
! !

!TOGemToolsHome methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:18'!
renderInspectorContentOn: html for: aTOInspector main: main
	aTOInspector getMembers.
	aTOInspector basicInspect
		ifTrue: [ ^ aTOInspector renderStandardContentOn: html main: main ].
	html strong: 'tOde operations:'.
	html unorderedList: [self renderControlsOn: html main: main].
	html strong: 'GemTools:'.
	html unorderedList: [self renderGemToolsOn: html main: main].
	html strong: 'Bookmarks:'.
	html unorderedList: [self renderBookmarksOn: html main: main].
	html horizontalRule.
	html horizontalRule.
	aTOInspector renderBasicToggleOn: html main: main.
! !

!TOGemToolsHome methodsFor: 'rendering' stamp: 'dkh 05/21/2011 12:41'!
renderToolsOn: html main: main

	self
		renderButton: [ :s | | objectLog fr |
			objectLog := TOObjectLog new.
			fr := self currentSession findFrameFor: objectLog.
			objectLog frame: fr.
			self currentSession push: objectLog selecting: #summary.
			main updateCenterSideHistory: s ]
		label: 'Object Log'
		on: html.
	html space.
	self
		renderButton: [ :s | | sbni sentNotImplemented |
			sbni := SentButNotImplementedTest new.
			(sentNotImplemented := sbni sentButNotImplemented) removeAllPresent: sbni specialCases.
			self currentSession push: sentNotImplemented selecting: #inspect.
			main updateCenterSideHistory: s ]
		label: 'Sent not Implemented'
		on: html.
	html space.
	self
		renderButton: [ :s | | us undefined dict |
			us := UndefinedSymbolsTest new.
			us cleanUndefinedSymbols.
			(undefined := UndefinedSymbols keys) removeAllPresent: us specialCases.
			dict := Dictionary new.
			undefined do: [:undef | dict at: undef put: (UndefinedSymbols at: undef) ].
			self currentSession push: dict selecting: #inspect.
			main updateCenterSideHistory: s ]
		label: 'Undefined Symbols'
		on: html.
! !

!TOGemToolsHome methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:19'!
renderWorkspacesOn: html main: main
	| inspector workspaces |
	workspaces := OrderedCollection new.
	(UserGlobals at: #SqueakWorkspace) keysAndValuesDo: [:name :contents | | fr ws |
		workspaces add: name->contents.
		"predefine the frames for the workspace string and set the contents of the workspace tab"
		fr := self currentSession findFrameFor: contents.
		(ws := fr rendererForCenterTab: #workspace) ifNotNil: [
			ws contents: contents ]].
	(workspaces sorted: [:a :b | a key <= b key ]) do: [:assoc |
		self
			renderButton: [ :s | | bms |
				self currentSession push: assoc value selecting: #workspace.
				main updateCenterSideHistory: s ]
			label: assoc key
			on: html.
		html space ]! !

TOView subclass: #TOObjectLog
	instanceVariableNames: 'summaryReport report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-GemTools'!

!TOObjectLog methodsFor: 'classic' stamp: 'dkh 05/21/2011 12:34'!
createClassicReport
	| columns |
	columns := (OrderedCollection new)
		add: ((WAReportColumn
			selector: #priorityString title: 'priority')
			sortBlock: [:a :b | a < b ];
			clickBlock: [:each | self currentSession push: each selecting: #inspect ]);
		add: ((WAReportColumn
			selector: #labelText title: 'Label')
			formatBlock: [:ea | ea ];
			sortBlock: [:a :b | a asString < b asString]);
		add: ((WAReportColumn
			selector: #pidString title: 'pid')
			sortBlock: [:a :b | a asNumber < b asNumber ]);
		add: ((WAReportColumn
			selector: #stampString 
			title: 'time')
			sortBlock: [:a :b | a > b ]);
		add: ((WAReportColumn
			selector: #requestString
			title: 'url')
			sortBlock: [:a :b | a < b ]);
		add: ((WAReportColumn
			selector: #objectString 
			title: 'object')
			sortBlock: [:a :b | a asString < b asString]);
		add: ((WAReportColumn
			selector: #deleteString title: 'delete down to'
			onClick: [ :each | self deleteLogEntriesUpToInclusive: each ])
			sortBlock: nil);
		add: ((WAReportColumn
			renderBlock: [ :each :html | 
				html anchor
					callback: [ self deleteLogEntry: each ];
					title: 'delete entry';
					with: 'me' ]
			title: 'delete')
			sortBlock: nil);
		yourself.
	^WAObjectLogTableReport new
		rows: self objectLog;
		columns: columns;
		rowColors: #(lightblue lightyellow);
		rowPeriod: 1;
		yourself.
	! !

!TOObjectLog methodsFor: 'summary' stamp: 'dkh 05/21/2011 08:18'!
createSummaryReport
	| labels summaryColumns |
	labels := self labels.
	summaryColumns := (OrderedCollection new)
		add: ((WAReportColumn
			renderBlock: [ :each :html | 
				html text: (labels at: each key) ]
			title: 'name')
			sortBlock: nil);
		add: ((WAReportColumn
			selector: #key title: 'priority')
			sortBlock: [:a :b | a < b ]);
		add: ((WAReportColumn
			selector: #value title: 'count')
			sortBlock: [:a :b | a < b ]);
		add: ((WAReportColumn
			renderBlock: [ :each :html | 
				each value == 0
					ifTrue: [ html text: '-' ]
					ifFalse: [
						html anchor
							callback: [ self deleteAllAtPriority: each ];
							title: 'delete';
							with: 'all ', (labels at: each key)] ]
			title: 'delete')
			sortBlock: nil);
		yourself.
	summaryReport := WAObjectLogTableReport new
		rows: self objectLogSummary;
		columns: summaryColumns;
		rowPeriod: 1;
		yourself.
	^summaryReport
	
! !

!TOObjectLog methodsFor: 'private' stamp: 'dkh 05/21/2011 08:19'!
deleteAllAtPriority: aSummaryEntry

	| priority log |
	priority := aSummaryEntry key.
	log := self getObjectLogEntries: true.
	(log select: [:ea | ea priority == priority ]) do: [:ea |  log remove: ea ifAbsent: []].! !

!TOObjectLog methodsFor: 'grid' stamp: 'dkh 05/21/2011 11:44'!
doGridSearch: aSearchRequest priority: priority using: jqGridColumns
	|filteredData sortedData pagedAndSortedData jqSortColumn|
	jqSortColumn := jqGridColumns columnForSearchRequest: aSearchRequest.
	filteredData := priority == nil
		ifTrue: [ self objectLog copy]
		ifFalse: [ self objectLog select: [:each | each priority = priority ]].
	aSearchRequest filterCriteriaDo: 
		[:aFilterCrit|
			filteredData 
				removeAllSuchThat: 
					[:each|
						((aFilterCrit jqGridColumn dataValueFor: each)
							perform: aFilterCrit operation with: aFilterCrit filterValue) not]].
	sortedData := 
		filteredData asSortedCollection:
			[:a :b| 
				((jqSortColumn dataValueFor: a) >= (jqSortColumn dataValueFor: b))
					xor: aSearchRequest isSortDescending].
	pagedAndSortedData := sortedData
		copyFrom: aSearchRequest startElementIndex 
		to: ((aSearchRequest endElementIndex) min: filteredData size).
	^JQGridSearchResponse new
		page: aSearchRequest pageNumber;
		totalNumberOfPages: (filteredData size / aSearchRequest numberOfRowsPerPage);
		totalNumberOfRecords: filteredData size;
		rowContents: 
			(pagedAndSortedData 
					collect: [:eachEntry|
						JQGridRowContent new
							id: eachEntry id;
							rowObject: eachEntry])! !

!TOObjectLog methodsFor: 'accessing' stamp: 'dkh 05/21/2011 08:16'!
getObjectLogEntries: shouldLock

	shouldLock 
		ifTrue: [
			System writeLock: ObjectLogEntry objectQueue
				ifDenied: [ 
					WARetryHttpRequest signal: 'ObjectLogEntry objectQueue lock denied'.
					"does not return" ]
				ifChanged: [ 
					System addToCommitOrAbortReleaseLocksSet: ObjectLogEntry objectQueue.
					WARetryHttpRequest signal: 'ObjectLogEntry objectQueue lock dirty'.
					"does not return" ].
			System addToCommitOrAbortReleaseLocksSet: ObjectLogEntry objectQueue].
	^ObjectLogEntry objectLog! !

!TOObjectLog methodsFor: 'accessing' stamp: 'dkh 05/21/2011 08:09'!
labels

	^#('fatal' 'error' 'warn' 'info' 'debug' 'trace' 'transcript').
! !

!TOObjectLog methodsFor: 'accessing' stamp: 'dkh 05/21/2011 08:17'!
objectLog

	^self getObjectLogEntries: false! !

!TOObjectLog methodsFor: 'summary' stamp: 'dkh 05/21/2011 08:12'!
objectLogSummary

	| sums summary |
	sums := Dictionary new.
	1 to: self labels size do: [:i | sums at: i put: 0 ].
	self objectLog do: [:ea | | tally |
		tally := sums at: ea priority.
		sums at: ea priority put: (tally + 1)].
	summary := Array new: self labels size.
	1 to: self labels size do: [:i| summary at: i put: (sums associationAt: i) ].
	^summary! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 12:30'!
renderClassicOn: html spec: ignored main: main

	self report rows: self objectLog reversed.
	html render: self report! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:55'!
renderDebugOn: html spec: aTOTabSpec main: main

	self renderEntry: ObjectLogEntry debug on: html spec: aTOTabSpec main: main! !

!TOObjectLog methodsFor: 'grid' stamp: 'dkh 05/21/2011 12:11'!
renderEntry: priority on: html spec: aTOTabSpec main: main

	html table 
		id:'grid_', priority printString; 
		script: (html jQuery this grid
			searchCallback: [:aSearchRequest :jqGridColumns| self doGridSearch: aSearchRequest priority: priority using: jqGridColumns];
			columns: 
				(JQGridColumns new
					add: ((JQGridColumn id: 'label' label: 'label' selector: #labelString) width: 400;yourself);
					add: ((JQGridColumn id: 'object' label: 'object' selector: #objectString) width: 400; yourself);
					add: ((JQGridColumn id: 'url' label: 'url' selector: #requestString) width: 50; yourself);
					add: ((JQGridColumn id: 'stamp' label: 'time' selector: #stamp) width: 200;   
							parseBlock: [:aString|DateAndTime fromString aString];  
							formatBlock: [:each|each printString];yourself);
					add: ((JQGridColumn id: 'pid' label: 'pid' selector: #pid) width: 50; 
							parseBlock: [:aString|aString asInteger]; 
							alignCenter; yourself);
					yourself);
			altRows: true;
			rowNum: 10;
			rowList: {10. 15. 20. 50};
			pagerId: 'pager_', priority printString;
			sortname: 'stamp';
			toolbarSearch;
			caption: 'Object Log: ', priority printString);
		with:''.
	html div id:'pager_', priority printString; with: ''.
! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:55'!
renderErrorOn: html spec: aTOTabSpec main: main

	self renderEntry: ObjectLogEntry error on: html spec: aTOTabSpec main: main! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:55'!
renderFatalOn: html spec: aTOTabSpec main: main

	self renderEntry: ObjectLogEntry fatal on: html spec: aTOTabSpec main: main! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:55'!
renderInfoOn: html spec: aTOTabSpec main: main

	self renderEntry: ObjectLogEntry info on: html spec: aTOTabSpec main: main! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 08:11'!
renderSummaryOn: html spec: aTOTabSpec main: main

	self summaryReport rows: self objectLogSummary.
	html render: self summaryReport! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:56'!
renderTraceOn: html spec: aTOTabSpec main: main

	self renderEntry: ObjectLogEntry trace on: html spec: aTOTabSpec main: main! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 07:56'!
renderTranscriptOn: html spec: aTOTabSpec main: main

	(self objectLog select: [:each | each priority = ObjectLogEntry transcript ]) do: [:entry |
		html text: entry object asString.
		html break ].! !

!TOObjectLog methodsFor: 'rendering' stamp: 'dkh 05/21/2011 08:05'!
renderWarnOn: html spec: aTOTabSpec main: main

	self renderEntry: ObjectLogEntry warn on: html spec: aTOTabSpec main: main! !

!TOObjectLog methodsFor: 'classic' stamp: 'dkh 05/21/2011 12:18'!
report

	report ifNil: [ report := self createClassicReport ].
	^report! !

!TOObjectLog methodsFor: 'summary' stamp: 'dkh 05/21/2011 08:18'!
summaryReport

	summaryReport ifNil: [ summaryReport := self createSummaryReport ].
	^summaryReport! !

!TOObjectLog methodsFor: 'accessing' stamp: 'dkh 05/21/2011 07:38'!
tODEFrameClassFor: aSession

	^TOObjectLogFrame! !
TOGemToolsHome initialize!
